"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PromiseSession = void 0;
const snmp = __importStar(require("net-snmp-typed"));
__exportStar(require("net-snmp-typed"), exports);
// 将 Session 类的方法转换为 Promise 风格
class PromiseSession {
    constructor(target, community, options) {
        this.session = snmp.createSession(target, community, options);
    }
    get(oids) {
        return new Promise((resolve, reject) => {
            this.session.get(oids, (error, varbinds) => {
                if (error) {
                    reject(error);
                }
                else {
                    resolve(varbinds);
                }
            });
        });
    }
    getNext(oids) {
        return new Promise((resolve, reject) => {
            this.session.getNext(oids, (error, varbinds) => {
                if (error) {
                    reject(error);
                }
                else {
                    resolve(varbinds);
                }
            });
        });
    }
    getBulk(oids, nonRepeaters, maxRepetitions) {
        return new Promise((resolve, reject) => {
            this.session.getBulk(oids, nonRepeaters, maxRepetitions, (error, varbinds) => {
                if (error) {
                    console.log(error);
                    reject(error);
                }
                else {
                    try {
                        const result = this.processBulkResponse(varbinds, nonRepeaters);
                        resolve(result);
                    }
                    catch (err) {
                        reject(err);
                    }
                }
            });
        });
    }
    processBulkResponse(varbinds, nonRepeaters) {
        const result = [];
        // Process non-repeaters
        for (let i = 0; i < Math.min(nonRepeaters, varbinds.length); i++) {
            const varbind = varbinds[i];
            this.processVarbind(varbind, result);
        }
        // Process repeaters
        for (let i = nonRepeaters; i < varbinds.length; i++) {
            const varbindArray = varbinds[i];
            for (const varbind of varbindArray) {
                this.processVarbind(varbind, result);
            }
        }
        return result;
    }
    processVarbind(varbind, result) {
        if (snmp.isVarbindError(varbind)) {
            throw snmp.varbindError(varbind);
        }
        result.push(varbind);
    }
    close() {
        this.session.close();
    }
}
exports.PromiseSession = PromiseSession;
